#include<stdio.h>
#include<stdlib.h>
#include "llist.h"

void panic(){
	puts("Not implemented yet!");
}

int menu(struct Node *head){
	int input, index, value;
	puts("\nWelcome to the menu for creation of linked lists.");
	puts("Displaying possible actions:");
	puts("1. Add at End;\n2. Delete Node;\n3. Insert Node;\n4. Search for value;\n5. Print a node;\n6. Print full list;\n7. Delete list and exit;\n8. Print node prior to selected.\n");
	fputs("Please input the number of your desired action: ",stdout);
	scanf("%d",&input);
	switch(input)
	{
		case 1: //append
			fputs("You have decided to insert a value at the end. Input the desired value now: ",stdout);
			scanf("%d",&value);
			add_to_end(head, value);
			break;
		case 2: //delete node at
			fputs("You have decided to delete a node. Input it: ",stdout);
			scanf("%d",&index);
			delete_node_at(head, index);
			break;
		case 3: //insert
			fputs("You have decided to insert a value at a specific point. Input the node index now: ",stdout);
			scanf("%d",&index);
			fputs("Please input the value now: ",stdout);
			scanf("%d",&value);
			insert_node(head, index, value);
			break;
		case 4: //search
			fputs("You have selected to search for a value. Please input the value now: ",stdout);
			scanf("%d",&value);
			psearch(head,value);
			break;
		case 5: //print node
			fputs("You have selected to print a node. Please input the node index now: ",stdout);
			scanf("%d",&index);
			print_node_at(head,index);
			break;
		case 6: //print list
			puts("Printing full list.");
			print_list(head);
			break;
		case 7: //delete list
			puts("Deleting the list...");
			delete_list(head);
			return 1;
		case 8: //return data two areas before
			puts("Returning data at offset");
			fputs("Please input the node index now: ",stdout);
			scanf("%d",&index);
			fputs("Please input the offset prior now: ",stdout);
			scanf("%d",&value);
			traverseBefore(head,index,value);
			break;
	}
	return 0;
}


int main(){

	struct Node *start;

	int arr[] = {10,20,30,40,50};
	start = construct_list(arr, 5);
	while(!menu(start))
	  ;
	return 0;

}
